import os
import sys
import numpy
import operator
import scipy.stats
import collections

rootdir = sys.argv[1]

for root, subdir, files in os.walk(rootdir):
    print 'Files in directory: '+root
    if root[-1]=='/':
        outFilename = root[:-1]+'_data'
    else:
        outFilename = root+'_data'
        root += '/'
    print 'Output file: '+outFilename

    data = []
    for inFilename in files:
        inFile = open(root+inFilename, 'r')
        flag = 0
        for line in inFile:
            line = line.split()
            if len(line)>0:
                if line[0]=='Tilt':
                    flag += 1
                elif flag==1:
                    flag += 1
                elif flag==2:
                    data.append([float(line[0]), float(line[1]), float(line[2])])

        inFile.close()

data_sorted = sorted(data, key=operator.itemgetter(0))

### Checks
for i in range(len(data_sorted)):
    if abs(data_sorted[i][0])>1e-10 and abs(data_sorted[i][0]-180)>1e-10:
        da_rot = abs(data_sorted[i+1][1]-data_sorted[i][1])
        break

data_array = numpy.array(data_sorted)
tilt_angles = data_array[:,0]
rot_angles = data_array[:,1]

# Values over 180 or under 0
over = numpy.where(tilt_angles>180+1e-10)[0]
under = numpy.where(tilt_angles<-1e-10)[0]

if len(over)>0:
    print 'Check over angles: '+str(tilt_angles[over])
if len(under)>0:
    print 'Check under angles: '+str(tilt_angles[under])

# Non-integer angles
nonint = numpy.where((tilt_angles%1)>1e-10)[0]
if len(nonint)>0:
    print 'Check non-integer angles: '+str(tilt_angles[nonint])

# Dupicated calculations
bin_lim = [tilt_angles[0]-1e-10]
da_tilt = []
alpha_tilt = []
for i in range(1,len(tilt_angles)):
    if abs(tilt_angles[i]-tilt_angles[i-1])>1e-10:
        bin_lim.append((tilt_angles[i]+tilt_angles[i-1])/2)
        da_tilt.append(tilt_angles[i]-tilt_angles[i-1])
        alpha_tilt.append(tilt_angles[i])
bin_lim.append(tilt_angles[-1]+1e-10)


max_mode = 360/da_rot

modes, lims = numpy.histogram(tilt_angles, bins=bin_lim)

duplicated = numpy.where(modes>max_mode)[0]

if len(duplicated)>0:
    print 'Check for duplication between %f and %f'%(bin_lim[duplicated],bin_lim[duplicated+1])

# Missing points
da_tilt = numpy.array(da_tilt)
alpha_tilt = numpy.array(alpha_tilt)
print '\nMaximum delta tilt: %f'%max(da_tilt)

max_tilt = numpy.where(abs(da_tilt-max(da_tilt))<1e-10)[0]

print 'Happens for angles: '+str(alpha_tilt[max_tilt])




outFile = open(outFilename, 'w')
for i in range(len(data_sorted)):
    outFile.write(str(data_sorted[i][0])+'\t'+str(data_sorted[i][1])+'\t'+str(data_sorted[i][2])+'\n')
outFile.close()
